#/usr/bin/python3


from synciterators import EIterator

from fileiterators import TransientJSON

import time

vecA = TransientJSON([x*2 for x in range(0, 100)])

vecB = TransientJSON([x*10 for x in range(5, 70)])

bf = lambda y, x: y < x
cs = lambda y, x: (x-5) <= y <= (x+5)

itA = vecA.eiterator()

print("\nexample #1\n")

start = time.time()
xx = [(b, itA.syncedWith(b, bf, cs)) for b in vecB ]
end = time.time()

print("time with Synchrony iterator: ", end - start, " seconds")


print("\nexample #2\n")

start = time.time()
xx = [(b, [ a for a in vecA if cs(a, b)]) for b in vecB ]
end = time.time()

print("time without Synchrony iterator: ", end - start, " seconds")



aa = [1, 2, 3]

start = time.time()
for i in range(0, 1000000):
    aa[0] += i
    aa[1] += i
    aa[2] += i
aa
end = time.time()

print("update time: ", end - start, " seconds")


aa = [1, 2, 3]

start = time.time()
for i in range(0, 1000000):
    aa = [ j + 1 for j in aa ]
aa  
end = time.time()

print("update time: ", end - start, " seconds")




#
# Demo of TextEFile
#


from textefiles import TextLine, TextEFile, TransientTextEFile, OnDiskTextEFile

vecA = TransientTextEFile([TextLine(x, str(x*2)) for x in range(0, 100)])

vecA.serialized("vecA")

vecB = OnDiskTextEFile("vecA")

print("\n*** This isvecB ***\n")

for b in vecB:
    print(b.lno, b.line)




